// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'VrMatrix.pas' rev: 5.00

#ifndef VrMatrixHPP
#define VrMatrixHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Menus.hpp>	// Pascal unit
#include <VrThreads.hpp>	// Pascal unit
#include <VrSysUtils.hpp>	// Pascal unit
#include <VrControls.hpp>	// Pascal unit
#include <VrClasses.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Vrmatrix
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TVrMatrixLedStyle { ls9x13, ls14x20, ls19x27 };
#pragma option pop

#pragma option push -b-
enum TVrMatrixScrollDirection { msdRightToLeft, msdLeftToRight };
#pragma option pop

#pragma option push -b-
enum TVrMatrixTextStyle { tsUpperCase, tsLowerCase, tsAsIs, tsProperCase };
#pragma option pop

class DELPHICLASS TVrMatrix;
class PASCALIMPLEMENTATION TVrMatrix : public Vrcontrols::TVrGraphicImageControl 
{
	typedef Vrcontrols::TVrGraphicImageControl inherited;
	
private:
	AnsiString FChars;
	AnsiString FColors;
	char FCurColor;
	int FPosition;
	Graphics::TBitmap* FLedImage;
	TVrMatrixLedStyle FLedStyle;
	int FLeds;
	bool FLedsVisible;
	int FSpacing;
	Vrcontrols::TVrAlignment FAlignment;
	Vrclasses::TVrPalette* FPalette;
	bool FAutoScroll;
	TVrMatrixScrollDirection FScrollDirection;
	TVrMatrixTextStyle FTextStyle;
	Vrcontrols::TVrOrientation FOrientation;
	Vrclasses::TVrBevel* FBevel;
	Vrthreads::TVrTimer* FTimer;
	Classes::TNotifyEvent FOnScrollDone;
	int __fastcall GetTimeInterval(void);
	bool __fastcall GetThreaded(void);
	void __fastcall SetLeds(int Value);
	void __fastcall SetSpacing(int Value);
	void __fastcall SetLedStyle(TVrMatrixLedStyle Value);
	void __fastcall SetLedsVisible(bool Value);
	void __fastcall SetPalette(Vrclasses::TVrPalette* Value);
	void __fastcall SetAlignment(Vrcontrols::TVrAlignment Value);
	void __fastcall SetAutoScroll(bool Value);
	void __fastcall SetTimeInterval(int Value);
	void __fastcall SetThreaded(bool Value);
	void __fastcall SetBevel(Vrclasses::TVrBevel* Value);
	void __fastcall SetTextStyle(TVrMatrixTextStyle Value);
	void __fastcall SetOrientation(Vrcontrols::TVrOrientation Value);
	void __fastcall PaletteModified(System::TObject* Sender);
	void __fastcall BevelChanged(System::TObject* Sender);
	void __fastcall TimerEvent(System::TObject* Sender);
	HIDESBASE MESSAGE void __fastcall CMColorChanged(Messages::TMessage &Message);
	MESSAGE void __fastcall CMSysColorChange(Messages::TMessage &Message);
	HIDESBASE MESSAGE void __fastcall CMTextChanged(Messages::TMessage &Message);
	
protected:
	virtual void __fastcall Loaded(void);
	virtual void __fastcall Paint(void);
	void __fastcall PaintLed(int X, int Y, char Ch, Graphics::TColor Color);
	void __fastcall PaintLeds(void);
	virtual void __fastcall LoadBitmaps(void);
	void __fastcall Decode(AnsiString S);
	virtual void __fastcall DoScrollDone(void);
	void __fastcall UpdateAlignment(void);
	
public:
	__fastcall virtual TVrMatrix(Classes::TComponent* AOwner);
	__fastcall virtual ~TVrMatrix(void);
	virtual void __fastcall SetBounds(int ALeft, int ATop, int AWidth, int AHeight);
	void __fastcall ScrollText(void);
	
__published:
	__property bool Threaded = {read=GetThreaded, write=SetThreaded, nodefault};
	__property TVrMatrixTextStyle TextStyle = {read=FTextStyle, write=SetTextStyle, default=0};
	__property Vrcontrols::TVrOrientation Orientation = {read=FOrientation, write=SetOrientation, default=1
		};
	__property int Leds = {read=FLeds, write=SetLeds, default=15};
	__property int Spacing = {read=FSpacing, write=SetSpacing, default=2};
	__property Vrclasses::TVrPalette* Palette = {read=FPalette, write=SetPalette};
	__property TVrMatrixLedStyle LedStyle = {read=FLedStyle, write=SetLedStyle, default=1};
	__property bool LedsVisible = {read=FLedsVisible, write=SetLedsVisible, default=1};
	__property bool AutoScroll = {read=FAutoScroll, write=SetAutoScroll, default=0};
	__property Vrcontrols::TVrAlignment Alignment = {read=FAlignment, write=SetAlignment, default=0};
	__property int TimeInterval = {read=GetTimeInterval, write=SetTimeInterval, default=500};
	__property TVrMatrixScrollDirection ScrollDirection = {read=FScrollDirection, write=FScrollDirection
		, default=0};
	__property Vrclasses::TVrBevel* Bevel = {read=FBevel, write=SetBevel};
	__property Classes::TNotifyEvent OnScrollDone = {read=FOnScrollDone, write=FOnScrollDone};
	__property Anchors ;
	__property Constraints ;
	__property Color ;
	__property DragCursor ;
	__property DragKind ;
	__property DragMode ;
	__property Hint ;
	__property ParentColor ;
	__property ParentShowHint ;
	__property PopupMenu ;
	__property ShowHint ;
	__property Text ;
	__property Visible ;
	__property OnClick ;
	__property OnContextPopup ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDock ;
	__property OnEndDrag ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnStartDock ;
	__property OnStartDrag ;
};


class DELPHICLASS TVrMatrixData;
class PASCALIMPLEMENTATION TVrMatrixData : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	AnsiString FOrigin;
	AnsiString FData;
	AnsiString FColors;
	char FCurrColor;
	TVrMatrixTextStyle FStyle;
	void __fastcall DecodeColorCode(AnsiString &S);
	void __fastcall InsertChar(AnsiString &S);
	
public:
	__fastcall TVrMatrixData(void);
	void __fastcall Decode(AnsiString S);
	void __fastcall SetStyle(TVrMatrixTextStyle Value);
	void __fastcall MoveLeft(void);
	void __fastcall MoveRight(void);
	void __fastcall Reset(void);
	__property AnsiString Data = {read=FData};
	__property AnsiString Colors = {read=FColors};
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TVrMatrixData(void) { }
	#pragma option pop
	
};


class DELPHICLASS TVrMatrixGroup;
class PASCALIMPLEMENTATION TVrMatrixGroup : public Vrcontrols::TVrGraphicImageControl 
{
	typedef Vrcontrols::TVrGraphicImageControl inherited;
	
private:
	Vrcontrols::TVrColInt FCols;
	Vrcontrols::TVrRowInt FRows;
	bool FAutoScroll;
	Vrclasses::TVrPalette* FPalette;
	Vrclasses::TVrBevel* FBevel;
	int FCharSpacing;
	int FLineSpacing;
	int FPixelSize;
	int FPixelSpacing;
	Classes::TStrings* FLines;
	Vrthreads::TVrTimer* FTimer;
	Graphics::TBitmap* FLedImage;
	Graphics::TBitmap* FMatrixImage;
	Vrcontrols::TVrScrollDirection FScrollDirection;
	Windows::TRect FViewPort;
	Classes::TAlignment FAlignment;
	TVrMatrixTextStyle FTextStyle;
	bool FInitialized;
	Classes::TList* FList;
	int __fastcall GetTimeInterval(void);
	bool __fastcall GetThreaded(void);
	void __fastcall SetCols(Vrcontrols::TVrColInt Value);
	void __fastcall SetRows(Vrcontrols::TVrRowInt Value);
	void __fastcall SetCharSpacing(int Value);
	void __fastcall SetLineSpacing(int Value);
	void __fastcall SetPixelSize(int Value);
	void __fastcall SetPixelSpacing(int Value);
	void __fastcall SetLines(Classes::TStrings* Value);
	void __fastcall SetPalette(Vrclasses::TVrPalette* Value);
	void __fastcall SetBevel(Vrclasses::TVrBevel* Value);
	void __fastcall SetThreaded(bool Value);
	void __fastcall SetAutoScroll(bool Value);
	void __fastcall SetAlignment(Classes::TAlignment Value);
	void __fastcall SetTextStyle(TVrMatrixTextStyle Value);
	void __fastcall SetTimeInterval(int Value);
	void __fastcall PaletteModified(System::TObject* Sender);
	void __fastcall BevelChanged(System::TObject* Sender);
	void __fastcall LinesChanged(System::TObject* Sender);
	void __fastcall TimerEvent(System::TObject* Sender);
	HIDESBASE MESSAGE void __fastcall CMColorChanged(Messages::TMessage &Message);
	MESSAGE void __fastcall CMSysColorChange(Messages::TMessage &Message);
	
protected:
	virtual void __fastcall Paint(void);
	void __fastcall CalcPaintParams(void);
	virtual void __fastcall Loaded(void);
	void __fastcall CreateLedImage(void);
	void __fastcall UpdateLed(int Index, char Ch, Graphics::TColor Color);
	void __fastcall UpdateRow(int ARow);
	void __fastcall FormatStrings(void);
	Windows::TRect __fastcall GetItemRect(int Index);
	void __fastcall CreateDataList(int Count);
	void __fastcall ClearDataList(bool FreeList);
	
public:
	__fastcall virtual TVrMatrixGroup(Classes::TComponent* AOwner);
	__fastcall virtual ~TVrMatrixGroup(void);
	void __fastcall Reset(void);
	
__published:
	__property bool Threaded = {read=GetThreaded, write=SetThreaded, nodefault};
	__property Vrcontrols::TVrColInt Cols = {read=FCols, write=SetCols, default=15};
	__property Vrcontrols::TVrRowInt Rows = {read=FRows, write=SetRows, default=7};
	__property bool AutoScroll = {read=FAutoScroll, write=SetAutoScroll, default=0};
	__property int CharSpacing = {read=FCharSpacing, write=SetCharSpacing, default=1};
	__property int LineSpacing = {read=FLineSpacing, write=SetLineSpacing, default=1};
	__property int PixelSize = {read=FPixelSize, write=SetPixelSize, default=1};
	__property int PixelSpacing = {read=FPixelSpacing, write=SetPixelSpacing, default=1};
	__property Classes::TStrings* Lines = {read=FLines, write=SetLines};
	__property Vrcontrols::TVrScrollDirection ScrollDirection = {read=FScrollDirection, write=FScrollDirection
		, default=0};
	__property Vrclasses::TVrPalette* Palette = {read=FPalette, write=SetPalette};
	__property Vrclasses::TVrBevel* Bevel = {read=FBevel, write=SetBevel};
	__property Classes::TAlignment Alignment = {read=FAlignment, write=SetAlignment, default=0};
	__property TVrMatrixTextStyle TextStyle = {read=FTextStyle, write=SetTextStyle, default=0};
	__property int TimeInterval = {read=GetTimeInterval, write=SetTimeInterval, default=500};
	__property Anchors ;
	__property Constraints ;
	__property Color ;
	__property DragCursor ;
	__property DragKind ;
	__property DragMode ;
	__property Hint ;
	__property ParentColor ;
	__property ParentShowHint ;
	__property PopupMenu ;
	__property ShowHint ;
	__property Visible ;
	__property OnClick ;
	__property OnContextPopup ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDock ;
	__property OnEndDrag ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnStartDock ;
	__property OnStartDrag ;
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Vrmatrix */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Vrmatrix;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// VrMatrix
